/*
 Author: Tonetta Ivan (Ruben) - 2016.01
- many thanks to God [Yahwéh, YHWH, Geova]: He made life possible, and all you can do with it;
- many thanks to my wife and my children for their patience;
- many thanks to Rory Walsh for Cabbage and his great support (http://forum.cabbageaudio.com/);
- many thanks to Iain McCurdy, for all the code you've shared (http://iainmccurdy.org/);
- many thanks to Riccardo Bianchini, Alessandro Cipriani, Giorgio Zucco, Jim Aikin for their wonderful books and "Vallste" for their support (http://triceratupuz.altervista.org/";
- many thanks to Barry Vercoe and all Csound developers in the world (http://www.csounds.com/);

I'm not a writer of professional code in csound; so what we present is a very simple addictive synth with 8 tunable partials divided into 2 groups of 4. 
The amplitude of each group is controlled by its own envelope. There is an LFO that controls the overall pitch

this is a porting of "Legacy Library\Library Reaktor 3\Essentials\Ensembles\Tutorial – Workshop\Workshop1\5 – Additive" synth on Csound; 
 */
<Cabbage>
form size(476,555), caption("Additive"), pluginID("plu1")
keyboard   bounds(004,413,468,100), middlec(2)

groupbox   bounds(004,004,198,300), colour(160,160,160,020), text("4 Harm"),     plant("4Harm1"){ 
vslider    bounds(002,025,050,200), channel("amp1"),   range(0.001,   1,   1,     1,    .01  ), text("1"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(050,025,050,200), channel("amp2"),   range(0.001,   1,   0,     1,    .01  ), text("2"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(098,025,050,200), channel("amp3"),   range(0.001,   1,   0,     1,    .01  ), text("3"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(146,025,050,200), channel("amp4"),   range(0.001,   1,   0,     1,    .01  ), text("4"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(-08,225,070,070), channel("tune1"),  range(0,       72,  0,     1,    1    ), text("Tune1"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(040,225,070,070), channel("tune2"),  range(0,       72,  0,     1,    1    ), text("Tune2"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(088,225,070,070), channel("tune3"),  range(0,       72,  0,     1,    1    ), text("Tune3"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(136,225,070,070), channel("tune4"),  range(0,       72,  0,     1,    1    ), text("Tune4"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
}
groupbox   bounds(210,004,198,300), colour(160,160,160,020), text("4 Harm"),     plant("4Harm2"){ 
vslider    bounds(002,025,050,200), channel("amp5"),   range(0.001,   1,   0,     1,    .01  ), text("5"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(050,025,050,200), channel("amp6"),   range(0.001,   1,   0,     1,    .01  ), text("6"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(098,025,050,200), channel("amp7"),   range(0.001,   1,   0,     1,    .01  ), text("7"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
vslider    bounds(146,025,050,200), channel("amp8"),   range(0.001,   1,   0,     1,    .01  ), text("8"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(-08,225,070,070), channel("tune5"),  range(0,       72,  0,     1,    1    ), text("Tune5"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(040,225,070,070), channel("tune6"),  range(0,       72,  0,     1,    1    ), text("Tune6"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(088,225,070,070), channel("tune7"),  range(0,       72,  0,     1,    1    ), text("Tune7"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(136,225,070,070), channel("tune8"),  range(0,       72,  0,     1,    1    ), text("Tune8"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
}
groupbox   bounds(004,308,198,100), colour(160,160,160,020), text("1-4 ADSR"), plant("ADSR1"){ 
rslider    bounds(-08,025,070,070), channel("a1"),     range(0.001,   5,   0.001, 1,    0.001), text("A"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(040,025,070,070), channel("d1"),     range(0.001,   5,   1,     1,    0.001), text("D"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(088,025,070,070), channel("s1"),     range(0.001,   1,   0.5,   1,    0.001), text("S"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(136,025,070,070), channel("r1"),     range(0.001,   10,  1,     1,    0.001), text("R"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
}
groupbox   bounds(210,308,198,100), colour(160,160,160,020), text("5-8 ADSR"), plant("ADSR2"){ 
rslider    bounds(-08,025,070,070), channel("a2"),     range(0.001,   5,   0.001, 1,    0.001), text("A"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(040,025,070,070), channel("d2"),     range(0.001,   5,   1,     1,    0.001), text("D"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(088,025,070,070), channel("s2"),     range(0.001,   1,   0.5,   1,    0.001), text("S"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(136,025,070,070), channel("r2"),     range(0.001,   10,  1,     1,    0.001), text("R"),      textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
}
groupbox   bounds(415,004,056,250), colour(160,160,160,020), text("LFO"),      plant("LFO"){ 
button     bounds(004,030,050,040), channel("button1"), text("Off, On"), colour:0(160,160,160,020), colour:1(000,000,255,255)
rslider    bounds(-07,090,070,070), channel("range"),  range(0,     100,   0,     1,    1    ), text("Range"),  textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
rslider    bounds(-07,170,070,070), channel("rate"),   range(0.01,    1,   0,     1,    0.01 ), text("Rate"),   textbox(1), colour(000,000,255,050), trackercolour(000,000,255,255), fontcolour(000,000,255,255)
}
groupbox   bounds(415,288,055,120), colour(160,160,160,020), text("MASTER"), plant("OneKnob"){ 
rslider    bounds(-12,033,080,080), channel("master"), range(0.001,   1,   0.5,   0.5,  .01  ), text("Master"), textbox(1), colour(255,000,000,050), trackercolour(255,000,000,255), fontcolour(255,000,000,255)  
}
groupbox   bounds(004,520,365,027), linethickness(0), plant("Background"), colour(160,160,160,020){
combobox   bounds(170,004,150,020), channel("combobox"), populate("*.snaps")
filebutton bounds(322,004,040,020), channel("save"), text("Save"),     populate("*.snaps")
label      bounds(004,006,180,015), align("left"), fontcolour("blue"),        text("Tonetta Ivan - 2016.02")
}
</Cabbage>
<CsoundSynthesizer> 
<CsOptions>
-n -d -+rtmidi=NULL -M0 --midi-velocity-amp=5 ; --midi-key-cps=4
</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 16
nchnls = 2
0dbfs=1

instr 1
; receiving GUI values
kmaster  chnget "master" 
kamp1    chnget "amp1"
kamp2    chnget "amp2"
kamp3    chnget "amp3"
kamp4    chnget "amp4"
kamp5    chnget "amp5"
kamp6    chnget "amp6"
kamp7    chnget "amp7"
kamp8    chnget "amp8"
itune1   chnget "tune1"
itune2   chnget "tune2"
itune3   chnget "tune3"
itune4   chnget "tune4"
itune5   chnget "tune5"
itune6   chnget "tune6"
itune7   chnget "tune7"
itune8   chnget "tune8"
ienva1   chnget "a1"
ienvd1   chnget "d1"
ienvs1   chnget "s1"
ienvr1   chnget "r1"
ienva2   chnget "a2"
ienvd2   chnget "d2"
ienvs2   chnget "s2"
ienvr2   chnget "r2"
krange   chnget "range"
krate    chnget "rate"
ibutton1 chnget "button1"
; little portamento for k signals: it kill the click when moving a GUI control
kamp1   portk kamp1,   0.01 
kamp2   portk kamp2,   0.01 
kamp3   portk kamp3,   0.01 
kamp4   portk kamp4,   0.01 
kamp5   portk kamp5,   0.01 
kamp6   portk kamp6,   0.01 
kamp7   portk kamp7,   0.01 
kamp8   portk kamp8,   0.01 
kmaster portk kmaster, 0.01
; MIDI note number value from MIDI IN
imidi notnum 
; Add toghether the MIDI note number and the GUI values 
inota1 cpsmidinn  imidi + itune1
inota2 cpsmidinn  imidi + itune2
inota3 cpsmidinn  imidi + itune3
inota4 cpsmidinn  imidi + itune4
inota5 cpsmidinn  imidi + itune5
inota6 cpsmidinn  imidi + itune6
inota7 cpsmidinn  imidi + itune7
inota8 cpsmidinn  imidi + itune8
; two MIDI ADSR for amplitude; two because this synth is build with two indipendent groups of Oscillators, (... 0, 1)
kenv1 madsr ienva1, ienvd1, ienvs1, ienvr1, 0, 1
kenv2 madsr ienva2, ienvd2, ienvs2, ienvr2, 0, 1
; If the LFO GUI button is pushed...
if (ibutton1 == 1) then
	{
		krate  = krate  * 10 ; receiving the rate values estabilished on GUI
		klfo oscil krange, krate, 1 ; generating an LFO
	}
else ; else, reset the value of klfo variable
	{
		klfo init 0
	}
endif
; Audio Engine: note that each oscillator have tiny frequency value added for moving the sound and the LFO values
a1 oscili kamp1, inota1+1+klfo, 1 
a2 oscili kamp2, inota2+2+klfo, 1 
a3 oscili kamp3, inota3+3+klfo, 1 
a4 oscili kamp4, inota4+4+klfo, 1 
a5 oscili kamp5, inota5+5+klfo, 1 
a6 oscili kamp6, inota6+6+klfo, 1 
a7 oscili kamp7, inota7+7+klfo, 1 
a8 oscili kamp8, inota8+8+klfo, 1 
; generation of two timbrical groups with different amplitude envelope
asum1 = ((a1+a2+a3+a4) * .25) * kenv1
asum2 = ((a5+a6+a7+a8) * .25) * kenv2
; Master amplitude controlled via GUI
aout = (asum1 + asum2) * .5
outs aout*kmaster, aout*kmaster
endin

</CsInstruments>  
<CsScore>
f1 0 4096 10 1
f0 3600
</CsScore>
</CsoundSynthesizer>